"""
Evaluate embeddings generated by the system described in, and using code released by,
Sasaki, 2019: "Subword-based Compact Reconstruction of Word Embeddings".

.. codeauthor:: Laurent Mertens <laurent.mertens@kuleuven.be>
"""
import os
import numpy as np

from eval.semeval2017 import SemEval2017
from eval.wordsim353 import WordSim353
from config import Config, Lang

in_file = os.path.join(Config.PRETRAINED_VECS_DIR, "Sasaki_wordsim353_en3.txt")
with open(in_file, 'r', encoding='utf-8', newline='\n', errors='ignore') as fin:
    data = {}

    nb_loaded = 0
    nb_zero = 0
    for line in fin:
        tokens = line.rstrip().split(' ')
        nb_alpha_tokens = len(tokens) - 300
        token = ' '.join(tokens[:nb_alpha_tokens])
        data[token] = np.asarray([x for x in map(float, tokens[-300:])])
        # Check for how many vectors no embeddings is present, i.e., all values are 0.
        # Yes, in theory there is a small chance that a non-zero vector will give sum == 0, but we
        # blissfully ignore this chance.
        if sum(data[token]) == 0.:
            nb_zero += 1

sem = WordSim353(ws_file=Config.EN_WORDSIM353_FILE)
res = sem.compute_score(data)
print(f"WordSim353: No embedding for nb. words: {nb_zero}")
print(f"WordSim353: {res[0]}")

in_file = os.path.join(Config.PRETRAINED_VECS_DIR, "Sasaki_semeval2017_en3.txt")
with open(in_file, 'r', encoding='utf-8', newline='\n', errors='ignore') as fin:
    data = {}

    nb_loaded = 0
    nb_zero = 0
    for line in fin:
        tokens = line.rstrip().split(' ')
        nb_alpha_tokens = len(tokens) - 300
        token = ' '.join(tokens[:nb_alpha_tokens])
        data[token] = np.asarray([x for x in map(float, tokens[-300:])])
        if sum(data[token]) == 0.:
            nb_zero += 1

sem = SemEval2017(lang=Lang.EN)
res = sem.compute_score(data)
print(f"SemEval2017: No embedding for nb. words: {nb_zero}")
print(f"SemEval2017: {res[0]}")
